//-------------------------------------------------
//
//   Class: L1MuDTTFSetup
//
//   Description: Setup the L1 barrel Muon Trigger Track Finder
//
//
//
//   Author :
//   N. Neumeister            CERN EP
//   J. Troconiz              UAM Madrid
//
//--------------------------------------------------

//-----------------------
// This Class's Header --
//-----------------------

#include "L1Trigger/DTTrackFinder/interface/L1MuDTTFSetup.h"

//---------------
// C++ Headers --
//---------------

#include <iostream>

//-------------------------------
// Collaborating Class Headers --
//-------------------------------

#include "L1Trigger/DTTrackFinder/interface/L1MuDTTrackFinder.h"

using namespace std;

// --------------------------------
//       class L1MuDTTFSetup
//---------------------------------

//----------------
// Constructors --
//----------------

L1MuDTTFSetup::L1MuDTTFSetup(const edm::ParameterSet& ps, edm::ConsumesCollector&& iC)
    : m_tf(new L1MuDTTrackFinder(ps, std::move(iC))) {
  // setup  the barrel Muon Trigger Track Finder
  m_tf->setup(std::move(iC));
}

//--------------
// Destructor --
//--------------

L1MuDTTFSetup::~L1MuDTTFSetup() { delete m_tf; }

//--------------
// Operations --
//--------------
